package com.pfe.www;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.ArrayList;

public class JSONFactory {

    private JSONObject jsonObject;

	public JSONFactory() { }

    public JSONObject makeProfileJSON (String androidId){
        jsonObject = new JSONObject();

        try {
            jsonObject.put("android_id", androidId);

        } catch (JSONException e) {
            e.printStackTrace();
        }
        return jsonObject;
    }

	public JSONObject makeSmsListJSON (String[] smsList, String androidId){
		jsonObject = new JSONObject();
		String value = "";
		String val = "value";

		try {
			jsonObject.put("android_id", androidId);
			for (int i = 0; i < smsList.length; i++) {
				value = val + i;
				jsonObject.put(value, smsList[i]);
			}		
		} catch (JSONException e) {
			e.printStackTrace();
		}
		return jsonObject;
	}

    public JSONObject makeWordsJSON(String[] words, String androidId){
        jsonObject = new JSONObject();
        JSONArray jA = new JSONArray();
        
        try {
            jsonObject.put("android_id", androidId);
            for (int i = 0; i < words.length; i++) {
                jA.put(words[i]);
            }
            jsonObject.put("words", jA.toString());
        } catch (JSONException e) {
            e.printStackTrace();
        }
        return jsonObject;
    }

    public JSONObject makeLocationJSON(Double latitude, Double longitude, Date date, String androidId) {
        jsonObject = new JSONObject();

        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        try {
            jsonObject.put("android_id", androidId);
            jsonObject.put("latitude", latitude);
            jsonObject.put("longitude", longitude);
            jsonObject.put("date", sdf.format(date));
        } catch (JSONException e) {
            e.printStackTrace();
        }
        return jsonObject;
    }

    public JSONObject makeWifiDeviceJSON(Date date, String androidId) {
        jsonObject = new JSONObject();

        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        try {
            jsonObject.put("android_id", androidId);
            jsonObject.put("date", sdf.format(date));
        } catch (JSONException e) {
            e.printStackTrace();
        }
        return jsonObject;
    }

    public JSONObject makeContactsJSON(ArrayList<Conversation> conversations, String androidId) {
        jsonObject = new JSONObject();

        try {
            jsonObject.put("android_id", androidId);

            JSONArray jsonArray = new JSONArray();
            for(Conversation conversation : conversations) {
                JSONObject jsonConversation = new JSONObject();
                jsonConversation.put("name", conversation.name);
                jsonConversation.put("number", conversation.number);
                jsonConversation.put("sms_count", conversation.smsCount);
                jsonArray.put(jsonConversation);
            }
            jsonObject.put("conversations", jsonArray);
        } catch (JSONException e) {
            e.printStackTrace();
        }
        return jsonObject;
    }
}
