package com.pfe.www;

import android.app.Service;
import android.content.Context;
import android.content.Intent;
import android.location.Location;
import android.location.LocationManager;
import android.location.LocationListener;
import android.os.Bundle;
import android.os.IBinder;
import android.provider.Settings.Secure;

import java.util.Date;

public class LocationService extends Service {

    private static long minTime = 1*60*1000;
    private static float minDistance = 100;

    private String androidId;
    private LocationManager locationManager = null;
    private LocationListener locationListener = new LocationListener() {
        @Override
        public void onLocationChanged(Location location) {
            JSONFactory jf = new JSONFactory();
            Sender sender = new Sender("http://petrumagdeleine.com/rest/addLocation", jf.makeLocationJSON(
                    location.getLatitude(),
                    location.getLongitude(),
                    new Date(),
                    androidId
            )
            );
            sender.post();
        }

        @Override
        public void onStatusChanged(String s, int i, Bundle bundle) {
        }

        @Override
        public void onProviderEnabled(String s) {
        }

        @Override
        public void onProviderDisabled(String s) {
        }
    };

    public LocationService() {
        super();
    }

    @Override
    public void onCreate() {
        androidId = ((GlobalClass)getApplicationContext()).getAndroidId();
        locationManager = (LocationManager)getSystemService(Context.LOCATION_SERVICE);
        locationManager.requestLocationUpdates(LocationManager.NETWORK_PROVIDER, minTime, minDistance, locationListener);
        locationManager.requestLocationUpdates(LocationManager.GPS_PROVIDER, minTime, minDistance, locationListener);
        super.onCreate();
    }

    @Override
    public int onStartCommand(Intent intent, int flags, int startId) {
        return super.onStartCommand(intent, flags, startId);
    }

    @Override
    public void onDestroy() {
        super.onDestroy();
        locationManager.removeUpdates(locationListener);
    }

    @Override
    public IBinder onBind(Intent intent) {
        // TODO: Return the communication channel to the service.
        throw new UnsupportedOperationException("Not yet implemented");
    }
}
