package com.pfe.www;

import android.content.ContentResolver;
import android.database.Cursor;
import android.net.Uri;

import java.util.ArrayList;

public class SMSProvider {

    public ContentResolver cr;
	public Uri smsUri;
	public Uri conversationUri;
	public Cursor c;
	public int smsCount;
	
	public SMSProvider(ContentResolver cr) {
		super();

        this.cr = cr;
		smsUri = Uri.parse("content://sms/inbox");
		conversationUri = Uri.parse("content://sms/conversations");
		
		setSMSCount();
	}

	public void setSMSCount(){
		c = cr.query(smsUri, new String [] { "_id"}, null, null, null);
		smsCount = c.getCount();
		c.close();
	}
	
	public SMS getLastSMS() {
		String [] reqCols = new String [] {"address", "date", "date_sent", "body", "type" };
		
		c = cr.query(smsUri, reqCols, null, null, "date DESC");
		c.moveToFirst();
				
		//received
		if(c.getString(4).equals("1")){
			return new SMS (c.getString(0), c.getString(1), c.getString(3), false, cr);
		//send
		} else if (c.getString(4).equals("2")) {
			return new SMS (c.getString(0), c.getString(2), c.getString(3), true, cr);
		}
		
		return null;
	}

	public Conversation getBestConversation() {
        String [] reqCols = new String [] { "msg_count", "thread_id"};

        c = cr.query(conversationUri, reqCols, null, null, "msg_count DESC");
        
        c.moveToFirst();
        
        String msg_count = c.getString(0);
        String thread_id = c.getString(1);
        
        reqCols = new String [] {"thread_id", "address"};
        c = cr.query(smsUri, reqCols, null, null, "thread_id ASC");
        
        c.moveToFirst();
        String name = "";
        for (int i = 0; i < c.getCount(); i++) {
        	if(thread_id.equals(c.getString(0))){
        		name = c.getString(1);
        	}
            c.moveToNext();
        }
        c.close();
   
		return new Conversation( name, Integer.parseInt(msg_count), cr);
	}

    public ArrayList<Conversation> getConversations() {
    	c = cr.query(conversationUri, null, null, null, "msg_count DESC");
        c.moveToFirst();
        
        ArrayList<Conversation> conversations = new ArrayList<Conversation>();
        
        for (int i = 0; i < c.getCount(); i++) {
            Cursor c2 = cr.query(smsUri, null, "thread_id="+c.getString(c.getColumnIndexOrThrow("thread_id")), null, null);
            if(c2.getCount() > 0) {
                c2.moveToFirst();
                conversations.add(
                    new Conversation(
                        c2.getString(c2.getColumnIndexOrThrow("address")),
                        Integer.parseInt(c.getString(c.getColumnIndexOrThrow("msg_count"))),
                        cr
                    )
                );
            }
            c.moveToNext();
        }
        c.close();

        return conversations;
    }
}
