package com.pfe.www;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.ArrayList;

import org.apache.http.HttpResponse;
import org.apache.http.NameValuePair;
import org.apache.http.client.HttpClient;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.message.BasicNameValuePair;
import org.json.JSONObject;

import android.os.AsyncTask;

public class Sender {

	public String url;
	public JSONObject jsonObject;
	
	public Sender(String url, JSONObject jsonObject) {
		this.url = url;
		this.jsonObject = jsonObject;
	}
	
	public void post(){
		new HttpAsyncTask().execute();
	}
	
	private class HttpAsyncTask extends AsyncTask<String, Void, String> {
        @Override
        protected String doInBackground(String... urls) {
            return POST();
        }

        @Override
        protected void onPostExecute(String result) {
        	System.out.println("Result : " + result);
       }
    }
	
	private String POST(){
		InputStream inputStream = null;
        String result = "";
        try {
            // 1. create HttpClient
            HttpClient httpclient = new DefaultHttpClient();
 
            // 2. make POST request to the given URL
            HttpPost httpPost = new HttpPost(url);
            String json = "";
 
            // 3. convert JSONObject to String
            json = jsonObject.toString();
 
            // 4. set json to ArrayList of NameValuePair
            ArrayList<NameValuePair> nameValuePairs = new ArrayList<NameValuePair>();
            nameValuePairs.add(new BasicNameValuePair("name", json));
 
            // 5. set httpPost Entity
            httpPost.setEntity(new UrlEncodedFormEntity(nameValuePairs));

            // 6. execute POST request to the given URL
            HttpResponse httpResponse = httpclient.execute(httpPost);

            // 7. receive response as inputStream
            inputStream = httpResponse.getEntity().getContent();
 
            // 8. convert inputStream to String
            if(inputStream != null)
            	result = convertInputStreamToString(inputStream);
            else
                result = "Did not work!";
 
        } catch (Exception e) {
            System.out.println("InputStream : " + e.getLocalizedMessage());
        }

        return result;
    }
	
	private static String convertInputStreamToString(InputStream inputStream) throws IOException{
        BufferedReader bufferedReader = new BufferedReader( new InputStreamReader(inputStream));
        String line = "";
        String result = "";
        while((line = bufferedReader.readLine()) != null)
            result += line;
 
        inputStream.close();
        return result;
    } 
}
